/*ghassan fakher
 * gkf01
 section 6*/

public class StackArray {
	private int[] stack;
	private int size;
	//constructor
	public StackArray()
	{
		stack = new int[100];
		size = 0;
	}
	//returns the number of elements in the stack
	public int getSize()
	{
		return size;
	}
	public boolean isEmpty()
	{
		boolean empty = false;
		if(size == 0)
			empty = true;
		return empty;
	}
	//increases the stack by the int given
	public void push(int val)
	{
		size++;
		if(size < stack.length)
			move();
		else
		{
			expandArray();
			move();
		}
		stack[0] = val;
	}
	//creates a new array twice the length but of same elements as the original
	private void expandArray()
	{
		int[] newArray = new int[2 * size];
		for(int i = 0; i < size; i++)
			newArray[i] = stack[i];
		stack = newArray;
	}
	//all the elements in the original are moved one step to the right once an integer is pushed
	private void move()
	{
		for(int i = size; i >= 0; i--)
			stack[i+1] = stack[i];
	}
	//returns and removes the element on top of the stack from the stack
	public int pop()
	{
		size--;
		int required = stack[0];
		for(int i = 1; i < stack.length; i++)
			stack[i - 1] = stack[i];
		return required;
	}
	//returns the element on top of the stack without removing it
	public int peek()
	{
		return stack[0];
	}
	public String toString()
	{
		String s = "";
		for(int i = 0; i < stack.length; i++)
			s += stack[i] + " ";
		return s;
	}
}
